--- emacs24-24.3+1.orig/lisp/progmodes/cc-defs.el
+++ emacs24-24.3+1/lisp/progmodes/cc-defs.el
@@ -1,32 +1,34 @@
 ;;; cc-defs.el --- compile time definitions for CC Mode
 
-;; Copyright (C) 1985, 1987, 1992-2013 Free Software Foundation, Inc.
+;; Copyright (C) 1985, 1987, 1992, 1993, 1994, 1995, 1996, 1997, 1998,
+;;   1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007, 2008, 2009,
+;;   2010, 2011   Free Software Foundation, Inc.
 
 ;; Authors:    2003- Alan Mackenzie
-;;             1998- Martin Stjernholm
-;;             1992-1999 Barry A. Warsaw
-;;             1987 Dave Detlefs
-;;             1987 Stewart Clamen
-;;             1985 Richard M. Stallman
+;;	       1998- Martin Stjernholm
+;;	       1992-1999 Barry A. Warsaw
+;;	       1987 Dave Detlefs and Stewart Clamen
+;;	       1985 Richard M. Stallman
 ;; Maintainer: bug-cc-mode@gnu.org
 ;; Created:    22-Apr-1997 (split from cc-mode.el)
-;; Keywords:   c languages
-;; Package:    cc-mode
+;; Version:    See cc-mode.el
+;; Keywords:   c languages oop
 
 ;; This file is part of GNU Emacs.
 
-;; GNU Emacs is free software: you can redistribute it and/or modify
+;; GNU Emacs is free software; you can redistribute it and/or modify
 ;; it under the terms of the GNU General Public License as published by
-;; the Free Software Foundation, either version 3 of the License, or
-;; (at your option) any later version.
+;; the Free Software Foundation; either version 3, or (at your option)
+;; any later version.
 
 ;; GNU Emacs is distributed in the hope that it will be useful,
 ;; but WITHOUT ANY WARRANTY; without even the implied warranty of
-;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.	 See the
 ;; GNU General Public License for more details.
 
 ;; You should have received a copy of the GNU General Public License
-;; along with GNU Emacs.  If not, see <http://www.gnu.org/licenses/>.
+;; along with this program; see the file COPYING.  If not, see
+;; <http://www.gnu.org/licenses/>.
 
 ;;; Commentary:
 
@@ -43,7 +45,7 @@
 	   load-path)))
     (load "cc-bytecomp" nil t)))
 
-(eval-when-compile (require 'cl)) ; was (cc-external-require 'cl).  ACM 2005/11/29.
+(cc-external-require 'cl)
 (cc-external-require 'regexp-opt)
 
 ;; Silence the compiler.
@@ -68,15 +70,14 @@
 	  (not (fboundp 'push)))
       (cc-load "cc-fix")))
 
-; (eval-after-load "font-lock"  ; 2006-07-09.  font-lock is now preloaded
-;   '
-(if (and (featurep 'xemacs)	; There is now (2005/12) code in GNU Emacs CVS
-				; to make the call to f-l-c-k throw an error.
-	 (not (featurep 'cc-fix)) ; only load the file once.
-	 (let (font-lock-keywords)
-	   (font-lock-compile-keywords '("\\<\\>"))
-	   font-lock-keywords))     ; did the previous call foul this up?
-    (load "cc-fix")) ;)
+(eval-after-load "font-lock"
+  '(if (and (not (featurep 'cc-fix)) ; only load the file once.
+	    (featurep 'xemacs) ; There is now (2005/12) code in GNU Emacs CVS
+			       ; to make the call to f-l-c-k throw an error.
+	    (let (font-lock-keywords)
+	      (font-lock-compile-keywords '("\\<\\>"))
+	      font-lock-keywords))     ; did the previous call foul this up?
+       (load "cc-fix")))
 
 ;; The above takes care of the delayed loading, but this is necessary
 ;; to ensure correct byte compilation.
@@ -90,10 +91,15 @@
 	       font-lock-keywords)))
       (cc-load "cc-fix")))
 
+;; XEmacs 21.4 doesn't have `delete-dups'.
+(eval-and-compile
+  (if (and (not (fboundp 'delete-dups))
+	   (not (featurep 'cc-fix)))
+      (cc-load "cc-fix")))
 
 ;;; Variables also used at compile time.
 
-(defconst c-version "5.32.4"
+(defconst c-version "5.33"
   "CC Mode version number.")
 
 (defconst c-version-sym (intern c-version))
@@ -104,7 +110,7 @@
 Otherwise, this variable is nil.  I.e. this variable is non-nil for
 `c-mode', `c++-mode', `objc-mode', `java-mode', `idl-mode',
 `pike-mode', `awk-mode', and any other non-CC Mode mode that calls
-`c-initialize-cc-mode'.  The value is the mode symbol itself
+`c-initialize-cc-mode'.	 The value is the mode symbol itself
 \(i.e. `c-mode' etc) of the original CC Mode mode, or just t if it's
 not known.")
 (make-variable-buffer-local 'c-buffer-is-cc-mode)
@@ -128,13 +134,13 @@ This variant works around bugs in `eval-
     (if c-inside-eval-when-compile
 	;; XEmacs 21.4.6 has a bug in `eval-when-compile' in that it
 	;; evaluates its body at macro expansion time if it's nested
-	;; inside another `eval-when-compile'.  So we use a dynamically
+	;; inside another `eval-when-compile'.	So we use a dynamically
 	;; bound variable to avoid nesting them.
 	`(progn ,@body)
 
       `(eval-when-compile
 	 ;; In all (X)Emacsen so far, `eval-when-compile' byte compiles
-	 ;; its contents before evaluating it.  That can cause forms to
+	 ;; its contents before evaluating it.	That can cause forms to
 	 ;; be compiled in situations they aren't intended to be
 	 ;; compiled.
 	 ;;
@@ -143,19 +149,19 @@ This variant works around bugs in `eval-
 	 ;; `nthcdr' is a primitive function that's handled specially by
 	 ;; the byte compiler and thus can't be redefined:
 	 ;;
-	 ;;     (defsubst nthcdr (val) val)
+	 ;;	(defsubst nthcdr (val) val)
 	 ;;
 	 ;; `defsubst', like `defmacro', needs to be evaluated at
 	 ;; compile time, so this will produce an error during byte
 	 ;; compilation.
 	 ;;
 	 ;; CC Mode occasionally needs to do things like this for
-	 ;; cross-emacs compatibility.  It therefore uses the following
+	 ;; cross-emacs compatibility.	It therefore uses the following
 	 ;; to conditionally do a `defsubst':
 	 ;;
-	 ;;     (eval-when-compile
-	 ;;       (if (not (fboundp 'foo))
-	 ;;           (defsubst foo ...)))
+	 ;;	(eval-when-compile
+	 ;;	  (if (not (fboundp 'foo))
+	 ;;	      (defsubst foo ...)))
 	 ;;
 	 ;; But `eval-when-compile' byte compiles its contents and
 	 ;; _then_ evaluates it (in all current emacs versions, up to
@@ -181,17 +187,17 @@ This variant works around bugs in `eval-
 The current point is used if POINT isn't specified.  POSITION can be
 one of the following symbols:
 
-`bol'   -- beginning of line
-`eol'   -- end of line
-`bod'   -- beginning of defun
-`eod'   -- end of defun
-`boi'   -- beginning of indentation
-`ionl'  -- indentation of next line
-`iopl'  -- indentation of previous line
-`bonl'  -- beginning of next line
-`eonl'  -- end of next line
-`bopl'  -- beginning of previous line
-`eopl'  -- end of previous line
+`bol'	-- beginning of line
+`eol'	-- end of line
+`bod'	-- beginning of defun
+`eod'	-- end of defun
+`boi'	-- beginning of indentation
+`ionl'	-- indentation of next line
+`iopl'	-- indentation of previous line
+`bonl'	-- beginning of next line
+`eonl'	-- end of next line
+`bopl'	-- beginning of previous line
+`eopl'	-- end of previous line
 `bosws' -- beginning of syntactic whitespace
 `eosws' -- end of syntactic whitespace
 
@@ -331,18 +337,27 @@ to it is returned.  This function does n
 	  (t (error "Unknown buffer position requested: %s" position))))
        (point))))
 
+(defmacro c-next-single-property-change (position prop &optional object limit)
+  ;; See the doc string for either of the defuns expanded to.
+  (if (and c-use-extents
+	   (fboundp 'next-single-char-property-change))
+      ;; XEmacs >= 2005-01-25
+      `(next-single-char-property-change ,position ,prop ,object ,limit)
+    ;; Emacs and earlier XEmacs
+    `(next-single-property-change ,position ,prop ,object ,limit)))
+
 (defmacro c-region-is-active-p ()
   ;; Return t when the region is active.  The determination of region
   ;; activeness is different in both Emacs and XEmacs.
-  (if (cc-bytecomp-boundp 'mark-active)
-      ;; Emacs.
-      'mark-active
-    ;; XEmacs.
-    '(region-active-p)))
+  (if (cc-bytecomp-fboundp 'region-active-p)
+      ;; XEmacs.
+      '(region-active-p)
+    ;; Emacs.
+    'mark-active))
 
 (defmacro c-set-region-active (activate)
   ;; Activate the region if ACTIVE is non-nil, deactivate it
-  ;; otherwise.  Covers the differences between Emacs and XEmacs.
+  ;; otherwise.	 Covers the differences between Emacs and XEmacs.
   (if (cc-bytecomp-fboundp 'zmacs-activate-region)
       ;; XEmacs.
       `(if ,activate
@@ -369,13 +384,20 @@ to it is returned.  This function does n
 (put 'c-safe 'lisp-indent-function 0)
 
 (defmacro c-int-to-char (integer)
-  ;; In Emacs, a character is an integer.  In XEmacs, a character is a
+  ;; In GNU Emacs, a character is an integer.  In XEmacs, a character is a
   ;; type distinct from an integer.  Sometimes we need to convert integers to
   ;; characters.  `c-int-to-char' makes this conversion, if necessary.
   (if (fboundp 'int-to-char)
       `(int-to-char ,integer)
     integer))
 
+(defmacro c-last-command-char ()
+  ;; The last character just typed.  Note that `last-command-event' exists in
+  ;; both Emacs and XEmacs, but with confusingly different meanings.
+  (if (featurep 'xemacs)
+      'last-command-char
+    'last-command-event))
+
 (defmacro c-sentence-end ()
   ;; Get the regular expression `sentence-end'.
   (if (cc-bytecomp-fboundp 'sentence-end)
@@ -405,7 +427,7 @@ properties to be changed, even in a read
 
 This macro should be placed around all calculations which set
 \"insignificant\" text properties in a buffer, even when the buffer is
-known to be writable.  That way, these text properties remain set
+known to be writeable.	That way, these text properties remain set
 even if the user undoes the command which set them.
 
 This macro should ALWAYS be placed around \"temporary\" internal buffer
@@ -473,7 +495,7 @@ various buffer change hooks."
 
   (let ((saved-undo-list (elt saved-state 0)))
     (if (eq buffer-undo-list saved-undo-list)
-	;; No change was done after all.
+	;; No change was done afterall.
 	(setq buffer-undo-list (cdr saved-undo-list))
 
       (if keep
@@ -510,7 +532,7 @@ LIMIT sets an upper limit of the forward
 LIMIT or the end of the buffer is reached inside a comment or
 preprocessor directive, the point will be left there.
 
-Note that this function might do hidden buffer changes.  See the
+Note that this function might do hidden buffer changes.	 See the
 comment at the start of cc-engine.el for more info."
   (if limit
       `(save-restriction
@@ -529,7 +551,7 @@ LIMIT sets a lower limit of the backward
 LIMIT is reached inside a line comment or preprocessor directive then
 the point is moved into it past the whitespace at the end.
 
-Note that this function might do hidden buffer changes.  See the
+Note that this function might do hidden buffer changes.	 See the
 comment at the start of cc-engine.el for more info."
   (if limit
       `(save-restriction
@@ -555,7 +577,7 @@ certain situations."
   `(c-forward-sexp ,(if (numberp count) (- count) `(- ,count))))
 
 (defmacro c-safe-scan-lists (from count depth &optional limit)
-  "Like `scan-lists' but returns nil instead of signaling errors
+  "Like `scan-lists' but returns nil instead of signalling errors
 for unbalanced parens.
 
 A limit for the search may be given.  FROM is assumed to be on the
@@ -582,7 +604,7 @@ right side of it."
 (defmacro c-go-list-forward ()
   "Move backward across one balanced group of parentheses.
 
-Return POINT when we succeed, NIL when we fail.  In the latter case, leave
+Return POINT when we succeed, NIL when we fail.	 In the latter case, leave
 point unmoved."
   `(c-safe (let ((endpos (scan-lists (point) 1 0)))
 	     (goto-char endpos)
@@ -591,7 +613,7 @@ point unmoved."
 (defmacro c-go-list-backward ()
   "Move backward across one balanced group of parentheses.
 
-Return POINT when we succeed, NIL when we fail.  In the latter case, leave
+Return POINT when we succeed, NIL when we fail.	 In the latter case, leave
 point unmoved."
   `(c-safe (let ((endpos (scan-lists (point) -1 0)))
 	     (goto-char endpos)
@@ -659,7 +681,7 @@ be after it."
 
 (defmacro c-go-down-list-forward (&optional pos limit)
   "Move the point to the first position inside the first list sexp after POS,
-or before the point if POS is left out.  Return t if such a position
+or before the point if POS is left out.	 Return t if such a position
 exists, otherwise nil is returned and the point isn't moved.
 
 A limit for the search may be given.  The start position is assumed to
@@ -673,7 +695,7 @@ be before it."
 
 (defmacro c-go-down-list-backward (&optional pos limit)
   "Move the point to the last position inside the last list sexp before POS,
-or before the point if POS is left out.  Return t if such a position
+or before the point if POS is left out.	 Return t if such a position
 exists, otherwise nil is returned and the point isn't moved.
 
 A limit for the search may be given.  The start position is assumed to
@@ -705,7 +727,7 @@ be after it."
 	 ,(when (cc-bytecomp-fboundp 'buffer-syntactic-context-depth)
 	    ;; XEmacs only.  This can improve the performance of
 	    ;; c-parse-state to between 3 and 60 times faster when
-	    ;; braces are hung.  It can also degrade performance by
+	    ;; braces are hung.	 It can also degrade performance by
 	    ;; about as much when braces are not hung.
 	    '(let (beginning-of-defun-function end-of-defun-function
 					       pos)
@@ -760,21 +782,21 @@ be after it."
 ;; non-nil if point (or the optional parameter POS) is at a VS, nil otherwise.
 ;;
 ;; The language specific function might well do extensive analysis of the
-;; source text, and may use a caching scheme to speed up repeated calls.
+;; source text, and may use a cacheing scheme to speed up repeated calls.
 ;;
 ;; The "virtual semicolon" lies just after the last non-ws token on the line.
-;; Like POINT, it is considered to lie between two characters.  For example,
+;; Like POINT, it is considered to lie between two characters.	For example,
 ;; at the place shown in the following AWK source line:
 ;;
-;;          kbyte = 1024             # 1000 if you're not picky
-;;                      ^
-;;                      |
-;;              Virtual Semicolon
+;;	    kbyte = 1024	     # 1000 if you're not picky
+;;			^
+;;			|
+;;		Virtual Semicolon
 ;;
 ;; In addition to `c-at-vsemi-p-fn', a mode may need to supply a function for
 ;; `c-vsemi-status-unknown-p-fn'.  The macro `c-vsemi-status-unknown-p' is a
 ;; rather recondite kludge.  It exists because the function
-;; `c-beginning-of-statement-1' sometimes tests for VSs as an optimization,
+;; `c-beginning-of-statement-1' sometimes tests for VSs as an optimisation,
 ;; but `c-at-vsemi-p' might well need to call `c-beginning-of-statement-1' in
 ;; its calculations, thus potentially leading to infinite recursion.
 ;;
@@ -784,7 +806,7 @@ be after it."
 ;; `c-beginning-of-statement-1'.  `c-vsemi-status-unknown-p' may not itself
 ;; call `c-beginning-of-statement-1'.
 ;;
-;; The macro `c-vsemi-status-unknown-p' will typically check the caching
+;; The macro `c-vsemi-status-unknown-p' will typically check the cacheing
 ;; scheme used by the `c-at-vsemi-p-fn', hence the name - the status is
 ;; "unknown" if there is no cache entry current for the line.
 ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
@@ -818,6 +840,8 @@ be after it."
 (defmacro c-with-syntax-table (table &rest code)
   ;; Temporarily switches to the specified syntax table in a failsafe
   ;; way to execute code.
+  ;; Maintainers' note: If TABLE is `c++-template-syntax-table', DON'T call
+  ;; any forms inside this that call `c-parse-state'.  !!!!
   `(let ((c-with-syntax-table-orig-table (syntax-table)))
      (unwind-protect
 	 (progn
@@ -906,38 +930,44 @@ MODE is either a mode symbol or a list o
 			       (cc-bytecomp-fboundp 'delete-extent)
 			       (cc-bytecomp-fboundp 'map-extents))))
 
+(defconst c-<-as-paren-syntax '(4 . ?>))
+(put 'c-<-as-paren-syntax 'syntax-table c-<-as-paren-syntax)
+
+(defconst c->-as-paren-syntax '(5 . ?<))
+(put 'c->-as-paren-syntax 'syntax-table c->-as-paren-syntax)
+
 ;; `c-put-char-property' is complex enough in XEmacs and Emacs < 21 to
 ;; make it a function.
-(defalias 'c-put-char-property-fun
-  (cc-eval-when-compile
-    (cond (c-use-extents
-	   ;; XEmacs.
-	   (byte-compile
-	    (lambda (pos property value)
-	      (let ((ext (extent-at pos nil property)))
-		(if ext
-		    (set-extent-property ext property value)
-		  (set-extent-properties (make-extent pos (1+ pos))
-					 (cons property
-					       (cons value
-						     '(start-open t
-						       end-open t)))))))))
-
-	  ((not (cc-bytecomp-boundp 'text-property-default-nonsticky))
-	   ;; In Emacs < 21 we have to mess with the `rear-nonsticky' property.
-	   (byte-compile
-	    (lambda (pos property value)
-	      (put-text-property pos (1+ pos) property value)
-	      (let ((prop (get-text-property pos 'rear-nonsticky)))
-		(or (memq property prop)
-		    (put-text-property pos (1+ pos)
-				       'rear-nonsticky
-				       (cons property prop)))))))
-	  ;; This won't be used for anything.
-	  (t 'ignore))))
+(eval-and-compile
+  (defalias 'c-put-char-property-fun
+    (cc-eval-when-compile
+      (cond (c-use-extents
+	     ;; XEmacs.
+	     (byte-compile
+	      (lambda (pos property value)
+		(let ((ext (extent-at pos nil property)))
+		  (if ext
+		      (set-extent-property ext property value)
+		    (set-extent-properties (make-extent pos (1+ pos))
+					   (cons property
+						 (cons value
+						       '(start-open t
+								    end-open t)))))))))
+
+	    ((not (cc-bytecomp-boundp 'text-property-default-nonsticky))
+	     ;; In Emacs < 21 we have to mess with the `rear-nonsticky' property.
+	     (byte-compile
+	      (lambda (pos property value)
+		(put-text-property pos (1+ pos) property value)
+		(let ((prop (get-text-property pos 'rear-nonsticky)))
+		  (or (memq property prop)
+		      (put-text-property pos (1+ pos)
+					 'rear-nonsticky
+					 (cons property prop)))))))))))
 (cc-bytecomp-defun c-put-char-property-fun) ; Make it known below.
 
-(defmacro c-put-char-property (pos property value)
+(eval-and-compile
+  (defmacro c-put-char-property (pos property value)
   ;; Put the given property with the given value on the character at
   ;; POS and make it front and rear nonsticky, or start and end open
   ;; in XEmacs vocabulary.  If the character already has the given
@@ -957,7 +987,27 @@ MODE is either a mode symbol or a list o
     ;; In Emacs 21 we got the `rear-nonsticky' property covered
     ;; by `text-property-default-nonsticky'.
     `(let ((-pos- ,pos))
-       (put-text-property -pos- (1+ -pos-) ',property ,value))))
+       (put-text-property -pos- (1+ -pos-) ',property ,value)))))
+
+(eval-and-compile
+  ;; Constant to decide at compilation time whether to use category
+  ;; properties.  Currently (2010-03) they're available only on GNU Emacs.
+  (defconst c-use-category
+    (let ((buf (generate-new-buffer " test"))
+	  parse-sexp-lookup-properties lookup-syntax-properties)
+      (prog1
+	  (save-excursion
+	    (set-buffer buf)
+	    (setq parse-sexp-lookup-properties t)
+	    (setq lookup-syntax-properties t)
+	    (set-syntax-table (make-syntax-table))
+	    (insert "<()>")
+	    (c-put-char-property (point-min) 'category 'c-<-as-paren-syntax)
+	    (c-put-char-property (+ 3 (point-min)) 'category 'c->-as-paren-syntax)
+	    (goto-char (point-min))
+	    (forward-sexp)
+	    (= (point) (+ 4 (point-min))))
+	(kill-buffer buf)))))
 
 (defmacro c-get-char-property (pos property)
   ;; Get the value of the given property on the character at POS if
@@ -1009,13 +1059,13 @@ MODE is either a mode symbol or a list o
 	 `(c-clear-char-property-fun ,pos ',property))))
 
 (defmacro c-clear-char-properties (from to property)
-  ;; Remove all the occurrences of the given property in the given
+  ;; Remove all the occurences of the given property in the given
   ;; region that has been put with `c-put-char-property'.  PROPERTY is
   ;; assumed to be constant.
   ;;
   ;; Note that this function does not clean up the property from the
   ;; lists of the `rear-nonsticky' properties in the region, if such
-  ;; are used.  Thus it should not be used for common properties like
+  ;; are used.	Thus it should not be used for common properties like
   ;; `syntax-table'.
   ;;
   ;; This macro does hidden buffer changes.
@@ -1039,8 +1089,8 @@ nil; point is then left undefined."
      (while
 	 (and
 	  (< place ,(or limit '(point-max)))
-	  (not (equal (get-text-property place ,property) ,value)))
-       (setq place (next-single-property-change
+	  (not (equal (c-get-char-property place ,property) ,value)))
+       (setq place (c-next-single-property-change
 		    place ,property nil ,(or limit '(point-max)))))
      (when (< place ,(or limit '(point-max)))
        (goto-char place)
@@ -1058,10 +1108,15 @@ point is then left undefined."
      (while
 	 (and
 	  (> place ,(or limit '(point-min)))
-	  (not (equal (get-text-property (1- place) ,property) ,value)))
-       (setq place (previous-single-property-change
+	  (not (equal (c-get-char-property (1- place) ,property) ,value)))
+       (setq place (,(if (and c-use-extents
+			      (fboundp 'previous-single-char-property-change))
+			 ;; XEmacs > 2005-01-25.
+			 'previous-single-char-property-change
+		       ;; Emacs and earlier XEmacs.
+		       'previous-single-property-change)
 		    place ,property nil ,(or limit '(point-min)))))
-     (when (> place ,(or limit '(point-max)))
+     (when (> place ,(or limit '(point-min)))
        (goto-char place)
        (search-backward-regexp ".")	; to set the match-data.
        (point))))
@@ -1070,17 +1125,17 @@ point is then left undefined."
   "Remove all text-properties PROPERTY from the region (FROM, TO)
 which have the value VALUE, as tested by `equal'.  These
 properties are assumed to be over individual characters, having
-been put there by c-put-char-property.  POINT remains unchanged."
+been put there by c-put-char-property.	POINT remains unchanged."
   (let ((place from) end-place)
-    (while			  ; loop round occurrences of (PROPERTY VALUE)
+    (while			  ; loop round occurrances of (PROPERTY VALUE)
 	(progn
 	  (while	   ; loop round changes in PROPERTY till we find VALUE
 	      (and
 	       (< place to)
 	       (not (equal (get-text-property place property) value)))
-	    (setq place (next-single-property-change place property nil to)))
+	    (setq place (c-next-single-property-change place property nil to)))
 	  (< place to))
-      (setq end-place (next-single-property-change place property nil to))
+      (setq end-place (c-next-single-property-change place property nil to))
       (remove-text-properties place end-place (cons property nil))
       ;; Do we have to do anything with stickiness here?
       (setq place end-place))))
@@ -1089,7 +1144,7 @@ been put there by c-put-char-property.
   "Remove all text-properties PROPERTY from the region [FROM, TO)
 which have the value VALUE, as tested by `equal'.  These
 properties are assumed to be over individual characters, having
-been put there by c-put-char-property.  POINT remains unchanged."
+been put there by c-put-char-property.	POINT remains unchanged."
   (if c-use-extents
     ;; XEmacs
       `(let ((-property- ,property))
@@ -1130,35 +1185,35 @@ been put there by c-put-char-property.
 
 
 ;; Make edebug understand the macros.
-;(eval-after-load "edebug" ; 2006-07-09: def-edebug-spec is now in subr.el.
-;  '(progn
-(def-edebug-spec cc-eval-when-compile t)
-(def-edebug-spec c-point t)
-(def-edebug-spec c-set-region-active t)
-(def-edebug-spec c-safe t)
-(def-edebug-spec c-save-buffer-state let*)
-(def-edebug-spec c-tentative-buffer-changes t)
-(def-edebug-spec c-forward-syntactic-ws t)
-(def-edebug-spec c-backward-syntactic-ws t)
-(def-edebug-spec c-forward-sexp t)
-(def-edebug-spec c-backward-sexp t)
-(def-edebug-spec c-up-list-forward t)
-(def-edebug-spec c-up-list-backward t)
-(def-edebug-spec c-down-list-forward t)
-(def-edebug-spec c-down-list-backward t)
-(def-edebug-spec c-add-syntax t)
-(def-edebug-spec c-add-class-syntax t)
-(def-edebug-spec c-benign-error t)
-(def-edebug-spec c-with-syntax-table t)
-(def-edebug-spec c-skip-ws-forward t)
-(def-edebug-spec c-skip-ws-backward t)
-(def-edebug-spec c-major-mode-is t)
-(def-edebug-spec c-put-char-property t)
-(def-edebug-spec c-get-char-property t)
-(def-edebug-spec c-clear-char-property t)
-(def-edebug-spec c-clear-char-properties t)
-(def-edebug-spec c-put-overlay t)
-(def-edebug-spec c-delete-overlay t) ;))
+(eval-after-load "edebug"
+  '(progn
+     (def-edebug-spec cc-eval-when-compile t)
+     (def-edebug-spec c-point t)
+     (def-edebug-spec c-set-region-active t)
+     (def-edebug-spec c-safe t)
+     (def-edebug-spec c-save-buffer-state let*)
+     (def-edebug-spec c-tentative-buffer-changes t)
+     (def-edebug-spec c-forward-syntactic-ws t)
+     (def-edebug-spec c-backward-syntactic-ws t)
+     (def-edebug-spec c-forward-sexp t)
+     (def-edebug-spec c-backward-sexp t)
+     (def-edebug-spec c-up-list-forward t)
+     (def-edebug-spec c-up-list-backward t)
+     (def-edebug-spec c-down-list-forward t)
+     (def-edebug-spec c-down-list-backward t)
+     (def-edebug-spec c-add-syntax t)
+     (def-edebug-spec c-add-class-syntax t)
+     (def-edebug-spec c-benign-error t)
+     (def-edebug-spec c-with-syntax-table t)
+     (def-edebug-spec c-skip-ws-forward t)
+     (def-edebug-spec c-skip-ws-backward t)
+     (def-edebug-spec c-major-mode-is t)
+     (def-edebug-spec c-put-char-property t)
+     (def-edebug-spec c-get-char-property t)
+     (def-edebug-spec c-clear-char-property t)
+     (def-edebug-spec c-clear-char-properties t)
+     (def-edebug-spec c-put-overlay t)
+     (def-edebug-spec c-delete-overlay t)))
 
 
 ;;; Functions.
@@ -1181,42 +1236,43 @@ been put there by c-put-char-property.
     (if (< (point) start)
 	(goto-char (point-max)))))
 
-(defconst c-<-as-paren-syntax '(4 . ?>))
-(put 'c-<-as-paren-syntax 'syntax-table c-<-as-paren-syntax)
-
-(defsubst c-mark-<-as-paren (pos)
+(defmacro c-mark-<-as-paren (pos)
   ;; Mark the "<" character at POS as a template opener using the
-  ;; `syntax-table' property via the `category' property.
+  ;; `syntax-table' property either directly (XEmacs) or via a `category'
+  ;; property (GNU Emacs).
   ;;
-  ;; This function does a hidden buffer change.  Note that we use
-  ;; indirection through the `category' text property.  This allows us to
+  ;; This function does a hidden buffer change.	 Note that we use
+  ;; indirection through the `category' text property.	This allows us to
   ;; toggle the property in all template brackets simultaneously and
   ;; cheaply.  We use this, for instance, in `c-parse-state'.
-  (c-put-char-property pos 'category 'c-<-as-paren-syntax))
+  (if c-use-category
+      `(c-put-char-property ,pos 'category 'c-<-as-paren-syntax)
+    `(c-put-char-property ,pos 'syntax-table c-<-as-paren-syntax)))
+  
 
-(defconst c->-as-paren-syntax '(5 . ?<))
-(put 'c->-as-paren-syntax 'syntax-table c->-as-paren-syntax)
-
-(defsubst c-mark->-as-paren (pos)
+(defmacro c-mark->-as-paren (pos)
   ;; Mark the ">" character at POS as an sexp list closer using the
-  ;; syntax-table property.
+  ;; `syntax-table' property either directly (XEmacs) or via a `category'
+  ;; property (GNU Emacs).
   ;;
-  ;; This function does a hidden buffer change.  Note that we use
-  ;; indirection through the `category' text property.  This allows us to
+  ;; This function does a hidden buffer change.	 Note that we use
+  ;; indirection through the `category' text property.	This allows us to
   ;; toggle the property in all template brackets simultaneously and
   ;; cheaply.  We use this, for instance, in `c-parse-state'.
-  (c-put-char-property pos 'category 'c->-as-paren-syntax))
-
-(defsubst c-unmark-<->-as-paren (pos)
-  ;; Unmark the "<" or "<" character at POS as an sexp list opener using
-  ;; the syntax-table property indirectly through the `category' text
-  ;; property.
+  (if c-use-category
+      `(c-put-char-property ,pos 'category 'c->-as-paren-syntax)
+    `(c-put-char-property ,pos 'syntax-table c->-as-paren-syntax)))
+
+(defmacro c-unmark-<->-as-paren (pos)
+  ;; Unmark the "<" or "<" character at POS as an sexp list opener using the
+  ;; `syntax-table' property either directly or indirectly through a
+  ;; `category' text property.
   ;;
-  ;; This function does a hidden buffer change.  Note that we use
+  ;; This function does a hidden buffer change.  Note that we try to use
   ;; indirection through the `category' text property.  This allows us to
   ;; toggle the property in all template brackets simultaneously and
   ;; cheaply.  We use this, for instance, in `c-parse-state'.
-  (c-clear-char-property pos 'category))
+  `(c-clear-char-property ,pos ,(if c-use-category ''category ''syntax-table)))
 
 (defsubst c-suppress-<->-as-parens ()
   ;; Suppress the syntactic effect of all marked < and > as parens.  Note
@@ -1234,7 +1290,7 @@ been put there by c-put-char-property.
 
 (defmacro c-with-<->-as-parens-suppressed (&rest forms)
   ;; Like progn, except that the paren property is suppressed on all
-  ;; template brackets whilst they are running.  This macro does a hidden
+  ;; template brackets whilst they are running.	 This macro does a hidden
   ;; buffer change.
   `(unwind-protect
        (progn
@@ -1249,7 +1305,7 @@ been put there by c-put-char-property.
 ;; which introduces a CPP construct and every EOL (or EOB, or character
 ;; preceding //, etc.) which terminates it.  We can instantly "comment
 ;; out" all CPP constructs by giving `c-cpp-delimiter' a syntax-table
-;; property '(14) (generic comment delimiter).
+;; propery '(14) (generic comment delimiter).
 (defmacro c-set-cpp-delimiters (beg end)
   ;; This macro does a hidden buffer change.
   `(progn
